COMMENT ^

Version 4.0
===========
This program will dock a popup window/dialog to a main window. If the popup window/dialog is moved to within 10
screen pixels of the main window, the popup window/dialog will dock automatically

When the main window moves the popup window/dialog is dragged with it.

When it is docked and then hidden, the popup window/dialog will be dragged in its invisible state with the main window.
When shown again, the popup window/dialog will still be docked.

The code could be tidied up; however, it has been presented in this format for clarity.
I have used 'T' and 'F' for True and False. This helped with the debugging as I could print these values on screen.
Had I used a boolean variable then more code would have been necessary for determining their values.

LEGAL NOTICE
============
1. Feel free to use this code in your own projects.
2. This code is provided free of charge. Therefore, this code may not be sold.
3. Users agree that the author of this code is not responisble for any damage caused by this code!

ACKNOWLEDGEMENTS
================
Steve Hutchinson who produced MASM32
Ketilo who produced RadAsm

CONTACTING THE AUTHOR
=====================
The author may be contacted via the asm users forum at www.masmforum.com.
If you use this code, then share your work with other asm coders via this forum.

; #########################################################################^
      .386                   ; minimum processor needed for 32 bit
      .model flat, stdcall   ; FLAT memory model & STDCALL calling
      option casemap :none   ; set code to case sensitive     
; ###############################################################################################      
      include \masm32\include\windows.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
; #########################################################################
	WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD
	WndProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
; #########################################################################
	CreateMyPopWin PROTO:DWORD, :DWORD 	;External procedures and external variables
	MoveDockedWin PROTO :Dword,:Dword
	
	EXTERNDEF hPopupWnd2 :DWORD
; #########################################################################	
    FileMenu		EQU	600     ;These menu constants are copied from the resource file
	CM_FileExit     EQU	102
    CM_HelpAbout	EQU	107
	CM_Show			EQU	108
	CM_Hide			EQU 109
	
.data
	szAppName           db "Docking Windows",0
    szClassName         db "BasicClass",0
	szAboutText         db "Docking Window demonstration",0
	CommandLine         dd 0
	hMainWnd            dd 0
	hInstance           dd 0
								
.code
; #########################################################################
start:
    invoke GetModuleHandle, NULL 
    mov hInstance, eax
    invoke GetCommandLine           
    mov CommandLine, eax
    invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT 
    invoke ExitProcess,eax       

; #########################################################################

WinMain proc hInst:DWORD, hPrevInst :DWORD, CmdLine:DWORD, CmdShow:DWORD

	LOCAL wc   :WNDCLASSEX
	LOCAL msg  :MSG
	LOCAL Wwd  :DWORD       ;Main window width
	LOCAL Wht  :DWORD       ;Main window height
	LOCAL Wtx  :DWORD		;Main window - x position
	LOCAL Wty  :DWORD		;Main window - y position
                       
     ; --------Fill WNDCLASSEX structure with required variables----------
        
	mov  wc.cbSize,         sizeof WNDCLASSEX
	mov  wc.style,          CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
	mov  wc.lpfnWndProc,    offset WndProc      ;address of WndProc
	mov  wc.cbClsExtra,     NULL
	mov  wc.cbWndExtra,     NULL
	push hInst
	pop  wc.hInstance
	mov  wc.hbrBackground,  COLOR_BTNFACE+1     ; system color
	mov  wc.lpszMenuName,   NULL
	mov  wc.lpszClassName,  offset szClassName  ;window class name
	invoke LoadIcon,hInst,	500                	;icon ID - resource icon
	mov  wc.hIcon,          eax
	invoke LoadCursor,NULL,IDC_ARROW         	;system cursor
	mov  wc.hCursor,        eax
	mov  wc.hIconSm,        0

	invoke RegisterClassEx, ADDR wc            	;register the window class
	mov  Wtx,200                        		;Initialise window x-position to 200 pixels
	mov  Wty,200								;Initialise window y-position to 200 pixels
	mov  Wwd,200                               	;Initialise window width to 200 pixels
	mov  Wht,200                               	;Initialise window height to 200 pixels
        
	invoke CreateWindowEx,WS_EX_LEFT+WS_EX_DLGMODALFRAME, ADDR szClassName, ADDR szAppName,
	                      WS_OVERLAPPEDWINDOW, Wtx,Wty,Wwd,Wht,NULL,NULL, hInst,NULL
                              
	mov  hMainWnd,eax                         	;copy return value into handle DWORD
	invoke LoadMenu,hInst,600                 	;load resource menu
	invoke SetMenu,hMainWnd,eax               	;set it to main window
	invoke ShowWindow,hMainWnd,SW_SHOWNORMAL  	;display the window
	invoke UpdateWindow,hMainWnd				;update the display

	invoke CreateMyPopWin, hInstance,hMainWnd	;create popup window

 ;============== Loop until PostQuitMessage is sent ===================    

StartLoop:
	invoke GetMessage,ADDR msg,NULL,0,0         ; get each message
	cmp eax, 0                                  ; exit if GetMessage()
	je ExitLoop                                 ; returns zero
	invoke TranslateMessage, ADDR msg           ; translate it
	invoke DispatchMessage,  ADDR msg           ; send it to message proc
	jmp StartLoop
	    
ExitLoop:
	mov eax, msg.wParam
	ret
WinMain endp

; #########################################################################

WndProc proc hWin: DWORD, uMsg: DWORD, wParam: DWORD, lParam: DWORD

    .if uMsg == WM_COMMAND
    
        ;======== menu commands ========

        .if wParam == CM_FileExit						;Exit command on file menu
            invoke SendMessage,hWin,WM_SYSCOMMAND,SC_CLOSE,NULL
            
        .elseif wParam == CM_HelpAbout					;About command on menu            
            invoke MessageBox,hWin,ADDR szAboutText,ADDR szAppName,MB_OK

        .elseif wParam==CM_Show  						;show popup

            invoke ShowWindow,hPopupWnd2,SW_SHOWNORMAL	;display the popup window
            invoke UpdateWindow,hPopupWnd2				;update the display

        .elseif wParam==CM_Hide							
            invoke ShowWindow,hPopupWnd2,SW_HIDE		;hide the popup window
        
                ;====== end menu commands ======
        .endif

	.elseif uMsg == WM_WINDOWPOSCHANGED
		;lParam will point to a WINPOS structure giving details of the position of the
		;moved main window when this message is used
		
		invoke MoveDockedWin,lParam,hMainWnd	;move docked window with main window

    .elseif uMsg == WM_DESTROY
        invoke PostQuitMessage,NULL
        mov eax,0
        ret
    .endif

    invoke DefWindowProc,hWin,uMsg,wParam,lParam
    ret
WndProc endp

; #########################################################################

end start