COMMENT ^

Version 3.0
===========
This program will dock a popup window/dialog to a main window. If the popup window/dialog is moved to within 10
screen pixels of the main window, the popup window/dialog will dock automatically

When the main window moves the popup window/dialog is dragged with it.

When it is docked and then hidden, the popup window/dialog will be dragged in its invisible state with the main window.
When shown again, the popup window/dialog will still be docked.

The code could be tidied up; however, it has been presented in this format for clarity.
I have used 'T' and 'F' for True and False. This helped with the debugging as I could print these values on screen.
Had I used a boolean variable then more code would have been necessary for determining their values.

The procedures for docking the second window could be rewritten to 
pass a pointer to to a structure containig the second, third.. windows
parameters to generalise the procedure.

LEGAL NOTICE
============
1. Feel free to use this code in your own projects.
2. This code is provided free of charge. Therefore, this code may not be sold.
3. Users agree that the author of this code is not responisble for any damage caused by this code!

ACKNOWLEDGEMENTS
================
Steve Hutchinson, author of MASM32
Ketilo who produced RadAsm

CONTACTING THE AUTHOR
=====================
The author may be contacted via the asm users forum at www.masmforum.com.
If you use this code, then share your work with other asm coders via this forum.

; #########################################################################^
      .386                   ; minimum processor needed for 32 bit
      .model flat, stdcall   ; FLAT memory model & STDCALL calling
      option casemap :none   ; set code to case sensitive
; #########################################################################      
      include \masm32\include\windows.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
; #########################################################################
	WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD
	WndProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
	CreateMyPopWin PROTO:DWORD,:DWORD,:DWORD,:DWORD,:DWORD  
	WndProc4MyPopup PROTO  :DWORD,: DWORD,: DWORD,: DWORD
	MoveDockedWindow PROTO :Dword
	DockWindow PROTO :Dword
; #########################################################################   
    FileMenu		EQU	600     ;These menu constants are copied from the resource file
	CM_FileExit     EQU	102
    CM_HelpAbout	EQU	107
	CM_Show			EQU	108
	CM_Hide			EQU 109
	
.data
	szAppName           db "Docking Windows",0
    szClassName         db "BasicClass",0
	szPopUpClassName    db "PopupWindowClass",0
	szAboutText         db "Docking Window demonstration",0
	szPopUpWinCaption   db "Popup Window",0
	CommandLine         dd 0
	hMainWnd            dd 0
	hPopupWnd           dd 0
	hInstance           dd 0
	DockedEdge2 		db 'R'	;byte indicates which edge of main window is docked to the 2nd window
								;Values: L, R, T, B
	Is2Docked			db 'T'	;Assume second window is docked to begin - set False if desired
	Is2Active 			db 'F'	;Assume second window is not active at start									
.code
; #########################################################################
start:
    invoke GetModuleHandle, NULL 
    mov hInstance, eax
    invoke GetCommandLine           
    mov CommandLine, eax
    invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT 
    invoke ExitProcess,eax       

; #########################################################################

WinMain proc hInst:DWORD, hPrevInst :DWORD, CmdLine:DWORD, CmdShow:DWORD

        LOCAL wc   :WNDCLASSEX
        LOCAL msg  :MSG
        LOCAL Wwd  :DWORD       ;Main window width
        LOCAL Wht  :DWORD       ;Main window height
        LOCAL Wtx  :DWORD
        LOCAL Wty  :DWORD
        
        LOCAL PopWwd    :DWORD  ;Pop up window parameters
        LOCAL PopWht    :DWORD
        LOCAL PopX      :DWORD
        LOCAL PopY      :DWORD
                
        ; --------Fill WNDCLASSEX structure with required variables----------
        
        mov  wc.cbSize,         sizeof WNDCLASSEX
        mov  wc.style,          CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
        mov  wc.lpfnWndProc,    offset WndProc      ;address of WndProc
        mov  wc.cbClsExtra,     NULL
        mov  wc.cbWndExtra,     NULL
        push hInst
        pop  wc.hInstance
        mov  wc.hbrBackground,  COLOR_BTNFACE+1     ; system color
        mov  wc.lpszMenuName,   NULL
        mov  wc.lpszClassName,  offset szClassName  ;window class name
        invoke LoadIcon,hInst,500                	;icon ID - resource icon
        mov  wc.hIcon,          eax
        invoke LoadCursor,NULL,IDC_ARROW         	;system cursor
        mov  wc.hCursor,        eax
        mov  wc.hIconSm,        0

        invoke RegisterClassEx, ADDR wc            	;register the window class

        mov  Wtx,200                        		;Initialise window x-position to 200 pixels
        mov  Wty,200								;Initialise window y-position to 200 pixels
        mov  Wwd,200                               	;Initialise window width to 200 pixels
        mov  Wht,200                               	;Initialise window height to 200 pixels
        
        invoke CreateWindowEx,WS_EX_LEFT+WS_EX_DLGMODALFRAME, ADDR szClassName, ADDR szAppName,
                              WS_OVERLAPPEDWINDOW, Wtx,Wty,Wwd,Wht,
                              NULL,NULL, hInst,NULL
                              
        mov  hMainWnd,eax                         	;copy return value into handle DWORD
        invoke LoadMenu,hInst,600                 	;load resource menu
        invoke SetMenu,hMainWnd,eax               	;set it to main window
        invoke ShowWindow,hMainWnd,SW_SHOWNORMAL  	;display the window
        invoke UpdateWindow,hMainWnd				;update the display

        mov  PopWwd,    200     ;Set popup width
        mov  PopWht,    200		;Set popup Height
        mov  PopX,      400		;Set popup X Position
        mov  PopY,      200		;Set popup Y Position

        invoke CreateMyPopWin, PopX, PopY, PopWwd, PopWht, hInstance ;create popup window

 ;============== Loop until PostQuitMessage is sent ===================    

    StartLoop:
      invoke GetMessage,ADDR msg,NULL,0,0         ; get each message
      cmp eax, 0                                  ; exit if GetMessage()
      je ExitLoop                                 ; returns zero
      invoke TranslateMessage, ADDR msg           ; translate it
      invoke DispatchMessage,  ADDR msg           ; send it to message proc
      jmp StartLoop
      
    ExitLoop:
      mov eax, msg.wParam
      ret
WinMain endp

; #########################################################################

WndProc proc hWin: DWORD, uMsg: DWORD, wParam: DWORD, lParam: DWORD

    .if uMsg == WM_COMMAND
    
        ;======== menu commands ========

        .if wParam == CM_FileExit						;Exit command on file menu
            invoke SendMessage,hWin,WM_SYSCOMMAND,SC_CLOSE,NULL
            
        .elseif wParam == CM_HelpAbout					;About command on menu            
            invoke MessageBox,hWin,ADDR szAboutText,ADDR szAppName,MB_OK

        .elseif wParam==CM_Show  						;show popup

            invoke ShowWindow,hPopupWnd,SW_SHOWNORMAL	;display the popup window
            invoke UpdateWindow,hPopupWnd				;update the display

        .elseif wParam==CM_Hide							
            invoke ShowWindow,hPopupWnd,SW_HIDE         ;hide the popup window
        
                ;====== end menu commands ======
        .endif

	.elseif uMsg == WM_WINDOWPOSCHANGED
		;lParam will point to a WINPOS structure giving details of the position of the
		;moved main window when this message is used
		
		invoke MoveDockedWindow,lParam	;move docked window with main window

    .elseif uMsg == WM_DESTROY
        invoke PostQuitMessage,NULL
        mov eax,0
        ret
    .endif

    invoke DefWindowProc,hWin,uMsg,wParam,lParam
    ret
WndProc endp

; #########################################################################

WndProc4MyPopup proc hWin: DWORD, uMsg: DWORD, wParam: DWORD, lParam: DWORD

	.if uMsg == WM_ACTIVATE
		mov al, FALSE		;Assume second window is not active
		mov Is2Active,al
		mov eax, wParam		;Loword of wParam indicates whether window has been activated or deactivated
		and	eax,0FFFFh		;Get low word of wParam in eax 
		cmp eax,WA_INACTIVE	;is the popup window activate?
		je NotActive		;No - take no further action
		mov al,TRUE			;Yes - set Is2Active to TRUE
		mov Is2Active, al
NotActive:

    .elseif uMsg == WM_WINDOWPOSCHANGING
    	;lparam points to a WindowPos structure
    	;this structure holds details about the position of the popup window and its size
    	;when this message is used
    	
		invoke DockWindow, lParam	;code to dock at side of main window
		
    .endif
    invoke DefWindowProc,hWin,uMsg,wParam,lParam
    ret
WndProc4MyPopup endp

CreateMyPopWin Proc PopX:DWORD, PopY:DWORD, PopWwd:DWORD, PopWht :DWORD, WinMainProcInst:DWORD  
    ; -------------------------------------------------------------------------------
    ; Creates and registers a new popup window 
    ;
    ; Called by:			
    ;
    ; Uses globals:         szPopUpClassName
    ;                       szPopUpWinCaption
    ;                       hPopupWnd
    ; Parameters:           PopX - x co-ordinate of popup
    ;                       PopY - y co-ordinate of popup
    ;                       PopWwd - Width of popup window in screen coordinates
    ;                       PopWht - Height of popup window in screen coordinates
    ;                       WinMainProcInst - HInst parameter of WinMain proc
    ; ------------------------------------------------------------------------------- 

        LOCAL pwc   :WNDCLASSEX

        ; -------- Fill Popup WNDCLASSEX structure with required variables ----------

        mov  pwc.cbSize,sizeof WNDCLASSEX
        mov  pwc.style,CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW or CS_NOCLOSE
        mov  pwc.lpfnWndProc,offset WndProc4MyPopup      	;address of WndProc4MyPopup
        mov  pwc.cbClsExtra,NULL
        mov  pwc.cbWndExtra,NULL
        push WinMainProcInst
        pop  pwc.hInstance
        mov  pwc.hbrBackground,COLOR_BTNFACE+1     			;use system colors
        mov  pwc.lpszMenuName, NULL
        mov  pwc.lpszClassName,offset szPopUpClassName  	;popup window class name
        invoke LoadIcon,WinMainProcInst,500                 ;icon ID - resource icon
        mov  pwc.hIcon,eax
        invoke LoadCursor,NULL,IDC_ARROW         			;use system cursor
        mov  pwc.hCursor,eax
        mov  pwc.hIconSm,0

        invoke RegisterClassEx, ADDR pwc            		;register the popup window class

        ; --------Create and register Popup window ----------

        invoke CreateWindowEx,WS_EX_LEFT, ADDR szPopUpClassName, ADDR szPopUpWinCaption,        
                              WS_POPUP or WS_BORDER or WS_CAPTION,                            
                              PopX,PopY,PopWwd,PopWht, hMainWnd,NULL, WinMainProcInst,NULL
        mov  hPopupWnd,eax  
        mov eax,0
        ret
CreateMyPopWin endp

; #########################################################################

DockWindow proc uses edi ecx, ptrSecondWindowPos:Dword
; ********************************************************************************************************************
; PURPOSE: This procedure docks a window or dialog box to an edge of the main window
;           
; USE: 	This procedure is called by the following code which should be placed in the callback procedure
;		for the PopUp window or dialog: 
;
;		.elseif uMsg == WM_WINDOWPOSCHANGING
;			invoke DockWindow, lParam	;lparam points to a WindowPos structure
;
; ON ENTRY: ptrSecondWindowPos is an lParam pointer to a WindowPos structure for the second window
;			
; USES:     hMainWnd - the handle of the main window
;           
; NOTE:     Adapted from a program written by Donkey for GoASM
;             
; ********************************************************************************************************************

	LOCAL MainWinRect : RECT

	invoke GetWindowRect, hMainWnd, ADDR MainWinRect    ;get main window co-ords int MainWinRect: left,top,right,bottom
	mov edi,ptrSecondWindowPos			;edi holds address of a WindowPos Structure for the 2nd window
										;compare the tops to see if they are close enough
	mov eax,[edi+WINDOWPOS.y]			;Get top edge of second window
	sub eax,[MainWinRect.top]			;Sub top edge of main window
	jns @F                              ;if result in eax is negative
	neg eax                    		    ;then make eax positive
@@:	
	cmp eax,10                          ;are the tops of each window more than 10 pixels apart?	
	jg CheckBottom						;Popup window is not docked at the side of the main window
										;so check if it is docked at top/bottom
	mov ecx,[MainWinRect.right]			;Get right edge of main window
	sub ecx,[edi+WINDOWPOS.x]			;Sub left edge of second window
	jns @F								;if result in eax is negative
	neg ecx                             ;then make eax positive
@@:
	cmp ecx,10							;are the sides greater than 10 pixels apart on the right side of main window?
	jg CheckLeft						;YES - Check left side
										;NO - Dock the window
	mov eax,[MainWinRect.right]			;Get the right co-ord of the main window
	mov [edi+WINDOWPOS.x],eax			;Store it in the left edge value of WindowPos for secondary window
	mov eax,[MainWinRect.top]			;Get the top co-ord of the main window
	mov [edi+WINDOWPOS.y],eax			;Store it in the top edge value of WindowPos for secondary window
	mov al,'R'							;Second window is docked to (R)ight of main window
	mov DockedEdge2,al
	mov Is2Docked, 'T'					;Set Is2Docked flag to true
	jmp EndDocking						;exit
	
CheckLeft:		
	mov eax,[edi+WINDOWPOS.x] 			;Get left edge of secondary window
	add eax,[edi+WINDOWPOS.lx]			;add width of secondary window to this value (=right edge)
	mov ecx,[MainWinRect.left]			;Get left co-ord of main window
	sub ecx,eax							;subtract left co-ordinates of each window
	jns @F								;if result in eax is negative
	neg ecx                             ;then make eax positive
@@:
	cmp ecx,10							;are the sides greater than 10 pixels apart on the left side of main window?
	jg  CheckBottom						;if not, check for docking at bottom of main window
										;else Dock the window
	mov eax,[MainWinRect.left]			;Get left co-ord of main window
	sub eax,[edi+WINDOWPOS.lx]			;sub width of secondary window from this value  (=right edge)
	mov [edi+WINDOWPOS.x],eax			;set left co-ord of second window
	mov eax,[MainWinRect.top]			;get top co-ord of main window
	mov [edi+WINDOWPOS.y],eax			;set top co-ord of second window
	mov al,'L'							;Second window is docked to (L)eft of main window
	mov DockedEdge2,al					;Store docked edge of main window
	mov Is2Docked, 'T'					;Set Is2Docked flag to true
	jmp EndDocking						;exit this procedure

CheckBottom:	
		;are left edges of the windows within 10 pixels of each other?	
	mov ecx,[MainWinRect.left]			;Get left edge of main window
	sub ecx,[edi+WINDOWPOS.x]			;Sub left edge of second window
	jns @F								;if result in ecx is negative
	neg ecx                             ;then make ecx positive
@@:
	cmp ecx,10							;are the left edges greater than 10 pixels apart?
	jg NotDocked						;Yes - end docking procedure	
	
	;is top of second window within 10 pixels of lower edge of main window?
	mov eax,[edi+WINDOWPOS.y]			;Get top edge of second window
	sub eax,[MainWinRect.bottom]		;Sub bottom edge of main window
	jns @F                              ;if result in eax is negative
	neg eax                    		    ;then make eax positive
@@:	
	cmp eax,10                          ;is top of 2nd window more than 10 pixels from bottom of main window?
	jg CheckMainTop                     ;If not, check edges at top of main window
										;YES - Dock the window at bottom of main window
	mov eax,[MainWinRect.bottom]		;Get the bottom co-ord of the main window
	mov [edi+WINDOWPOS.y],eax			;Store it in the top edge value of WindowPos for secondary window
	mov eax,[MainWinRect.left]			;Get the left co-ord of the main window
	mov [edi+WINDOWPOS.x],eax			;Store it in the left edge value of WindowPos for secondary window
	mov al,'B'							;Second window is docked to (B)ottom of main window
	mov DockedEdge2,al					;Store docked edge of main window
	mov Is2Docked, 'T'					;Set Is2Docked flag to true
	jmp EndDocking						;exit

CheckMainTop:
	;is bottom edge of second window within 10 pixels of top edge of main window?
	mov eax,[edi+WINDOWPOS.y] 			;Get top edge of secondary window
	add eax,[edi+WINDOWPOS.cy]			;add height of secondary window to this value (=bottom edge)
	mov ecx,[MainWinRect.top]			;Get top co-ord of main window
	sub ecx,eax							;subtract co-ordinates of each window
	jns @F								;if result in eax is negative
	neg ecx                             ;then make ecx positive
@@:
	cmp ecx,10                          ;are the edges of each window more than 10 pixels apart?	
	jg EndDocking                       ;If so, jump to EndDocking
										;else Dock the window at the top of the main window
	mov eax,[MainWinRect.left]			;Get left co-ord of main window	
	mov [edi+WINDOWPOS.x],eax			;set left co-ord of second window
	
	mov eax,[MainWinRect.top]			;get top co-ord of main window
	sub eax,[edi+WINDOWPOS.cy]			;sub height of second window
	mov [edi+WINDOWPOS.y],eax			;set top co-ord of second window
	mov al,'T'							;Second window is docked to (B)ottom of main window
	mov DockedEdge2,al					;Store docked edge of main window
	mov Is2Docked, 'T'					;Set Is2Docked flag to true
	jmp EndDocking
NotDocked:
	mov al,Is2Active					;is the popup window active?
	cmp al, TRUE					
	jne EndDocking						;No - end procedure
	mov Is2Docked, 'F'					;Yes - set the Is2Docked flag to false
EndDocking:
	ret
DockWindow endp
; #########################################################################

MoveDockedWindow proc uses edi, ptrMainWindowPos:Dword
; ********************************************************************************************************************
; PURPOSE: 	This procedure moves a docked popup window or docked dialog box with the main window
;			when the main window is moved
;
; USE: 	This procedure is called by the following code which should be placed in the callback procedure
;		for the Main window:
;
;		.elseif uMsg == WM_WINDOWPOSCHANGED
;		invoke MoveDockedWindow,lParam
;
; ON ENTRY: ptrMainWindowPos is the lParam pointer to a WindowPos structure for the poopup window/dialog
;			
; USES:     hPopupWnd - the handle of the popup window or dialog box
;           
; NOTE:     
;             
; ********************************************************************************************************************

	LOCAL SecondWinRect : RECT
	LOCAL SecondWinWidth : DWORD
	LOCAL SecondWinHeight : DWORD
	LOCAL xPos,yPos : DWORD
	
		mov al,Is2Docked					;If the popup window is not docked...
		cmp al, 'F'
		je EndPosChange						;...then exit this procedure
		
		invoke GetWindowRect, hPopupWnd, ADDR SecondWinRect    ;get 2nd window co-ords in SecondWinRect: left,top,right,bottom
		mov eax,SecondWinRect.right
		sub eax,SecondWinRect.left			;calculate width of second window
		mov SecondWinWidth,eax				;store width of second window
		mov eax,SecondWinRect.bottom
		sub eax,SecondWinRect.top			;calculate height of second window
		mov SecondWinHeight,eax				;store height of second window
		
		mov edi,ptrMainWindowPos ;ptrMainWindowPos holds a WinPos structure for the new position of the main window
		mov al,DockedEdge2
		cmp al,'L'
		jne NotDLeft
			;Move popup window so that it keeps against the left edge of main window here	
		mov eax,[edi+WINDOWPOS.x]			;Get position of left edge of main window
		sub eax,SecondWinWidth
		mov xPos,eax						;xPos = MainLeft-SecondWidth
		mov eax,[edi+WINDOWPOS.y]			;Get top edge of main window
		mov yPos,eax						;yPos = value of top edge of main window
	
		invoke MoveWindow,hPopupWnd,xPos,yPos,SecondWinWidth,SecondWinHeight,TRUE
		jmp EndPosChange	
NotDLeft:
		cmp al,'R'
		jne NotDRight
		;Move popup window so that it keeps against the right edge of main window here
		mov eax,[edi+WINDOWPOS.x]			;Get position of left edge of main window
		add eax,[edi+WINDOWPOS.lx]			;add width of the main window
		mov xPos,eax
		mov eax,[edi+WINDOWPOS.y]			;Get top edge of main window
		mov yPos,eax						;yPos = value of top edge of main window			
		invoke MoveWindow,hPopupWnd,xPos,yPos,SecondWinWidth,SecondWinHeight,TRUE
		jmp EndPosChange
NotDRight:
		cmp al,'T'
		jne NotDTop
		;Move popup window so that it keeps against the top edge of main window here
		mov eax,[edi+WINDOWPOS.y]			;Get top edge of main window
		sub eax, SecondWinHeight			;Subtract height of popup window
		mov yPos,eax						;yPos = Top of main window - height of popup window
		mov eax,[edi+WINDOWPOS.x]			;Get position of left edge of main window
		mov xPos,eax
		invoke MoveWindow,hPopupWnd,xPos,yPos,SecondWinWidth,SecondWinHeight,TRUE 
		jmp EndPosChange
NotDTop:
		;Move popup window so that it keeps against the bottom edge of main window here
		mov eax,[edi+WINDOWPOS.y]			;Get top edge of main window
		add eax,[edi+WINDOWPOS.cy]			;Add height of main window
		mov yPos,eax						;= y position of popup window
		mov eax,[edi+WINDOWPOS.x]			;Get position of left edge of main window
		mov xPos,eax		
		invoke MoveWindow,hPopupWnd,xPos,yPos,SecondWinWidth,SecondWinHeight,TRUE 	
EndPosChange:	
	ret
MoveDockedWindow endp
end start